<script setup>
import { Icon } from '@iconify/vue'
import { ref } from 'vue'
import { storeToRefs } from 'pinia'
import { useFileContextMenu } from '@/store/file-context-menu'
import { useBlocStore } from '@/store/bloc'

const fileContextMenu = ref(null)

const { targetedBloc } = storeToRefs(useFileContextMenu())
const fileContextMenuStore = useFileContextMenu()
const blocStore = useBlocStore()

const emit = defineEmits([
  'event-rename',
  'event-move',
  'event-favorite',
  'event-share',
  'event-download',
  'event-delete'
])

const closeMenuBeforeEmit = (event, emitName) => {
  fileContextMenu.value.classList.remove('visible')
  emit(emitName, event, fileContextMenuStore.bid)
}

const handleFavorite = () => {
  blocStore.toggleFavorite(fileContextMenuStore.bid)
  fileContextMenu.value.classList.remove('visible')
}
</script>

<template>
  <ul ref="fileContextMenu" id="file-context-menu" class="context-menu-base">
    <li class="context-menu-base__action" @click="closeMenuBeforeEmit($event, 'event-rename')">
      <span>
        <Icon icon="mdi:form-textbox" width="16px" height="16px" />
        Rename
      </span>
    </li>
    <li class="context-menu-base__action" @click="closeMenuBeforeEmit($event, 'event-move')">
      <span>
        <Icon icon="mdi:arrow-right-top" width="16px" height="16px" />
        Move to
      </span>
    </li>
    <li v-if="!targetedBloc.is_directory ?? false" class="context-menu-base__action" @click="handleFavorite">
      <span class="context-menu-base__action--separation">
        <Icon v-show="targetedBloc.is_favorite" icon="mdi:star" width="16px" height="16px" />
        <Icon v-show="!targetedBloc.is_favorite" icon="mdi:star-outline" width="16px" height="16px" />
        {{ targetedBloc.is_favorite ? 'Unstar' : 'Star' }}
      </span>
    </li>
<!--    <li class="context-menu-base__action" @click="closeMenuBeforeEmit($event, 'handle-share')">-->
<!--      <span>-->
<!--        <Icon icon="mdi:account-multiple-outline" width="16px" height="16px" />-->
<!--        Share-->
<!--      </span>-->
<!--    </li>-->
    <li v-if="!targetedBloc.is_directory ?? false" class="context-menu-base__action" @click="closeMenuBeforeEmit($event, 'event-download')">
      <span class="context-menu-base__action--separation">
        <Icon icon="mdi:download-outline" width="16px" height="16px" />
        Download
      </span>
    </li>
    <li class="context-menu-base__action" @click="closeMenuBeforeEmit($event, 'event-delete')">
      <span>
        <Icon icon="mdi:trash-outline" width="16px" height="16px" />
        Delete
      </span>
    </li>
  </ul>
</template>

<style lang="scss">
  #file-context-menu {
    position: fixed;
    z-index: 2000;
    display: none;
    &.visible {
      display: flex;
    }
  }

  .context-menu-base__action {
    &:hover > .action-rename {
      display: flex;
    }
  }

  .action-rename.context-menu-base {
    position: absolute;
    top: -9px;
    left: calc(100% + 1px);
    display: none;
    padding: 8px;
    > .rename-input {
      background-color: $complementary-gray-1;
      border: 1px solid $complementary-white-25;
      outline: none;
      border-radius: 8px;
      height: 2rem;
      color: $complementary-white;
      padding-left: 13px;
      ::placeholder {
        color: $complementary-white-25;
      }
    }
  }
</style>
